#include "stdafx.h"
#include "DirectDraw.h"
#include "Utility\ddutil.h"

//----
// RXgN^
//----
DirectDraw::DirectDraw() :
	// A^b`EBhEnh
	  m_hWnd(NULL)
	// XN[
	, m_ScreenInfo()
	// tXN[
	, m_bFullScreen(false)
	// DirectDraw IuWFNg
	, m_pDD(NULL)
	// DirectDraw vC}T[tFX
	, m_pDDSPrimary(NULL)
	// DirectDraw obNT[tFX
	, m_pDDSBack(NULL)
	// DirectDraw ItXN[T[tFX
	, m_pDDSOffScreen(NULL)
	// DirectDraw vC}T[tFXNbp[IuWFNg
	, m_pDDPrimaryClipper(NULL)
	// vC}
	, m_Primary()
	// obN
	, m_Back()
	// ItXN[
	, m_OffScreen()
	// ItXN[
	, m_OffScreenInfo()
	// ItXN[̋ë
	, m_OffScreenRange(64, 64)
{
}

//----
// fXgN^
//----
DirectDraw::~DirectDraw()
{
	// s܂
	Release();
}

//----
// XN[擾pR[obN֐
//----
HRESULT CALLBACK EnumModesCallback(LPDDSURFACEDESC2 pDDSD, LPVOID Context)
{
	vector<DirectDraw::ScreenInfo>* pList = (vector<DirectDraw::ScreenInfo>*)Context;

	// 𑜓xWς܂
	DirectDraw::ScreenInfo Info;
	Info.dwWidth = pDDSD->dwWidth;
	Info.dwHeight = pDDSD->dwHeight;
	Info.dwRGBBitCount = pDDSD->ddpfPixelFormat.dwRGBBitCount;
	pList->push_back(Info);

	return DDENUMRET_OK;
}

//----
// XN[擾܂
// return	XN[ꗗ
//----
vector<DirectDraw::ScreenInfo> DirectDraw::GetScreenInfo()
{
	vector<ScreenInfo> List;

	// DirectDraw CX^X𐶐܂
	LPDIRECTDRAW7 pDD;
	HRESULT hResult = ::DirectDrawCreateEx(NULL, (LPVOID*)&pDD, IID_IDirectDraw7, NULL);
	if(hResult != DD_OK)
	{
		return List;
	}

	// 񋓂܂
	pDD->EnumDisplayModes(DDEDM_REFRESHRATES, NULL, &List, EnumModesCallback);

	pDD->Release();

	return List;
}

//----
// XN[񂪈v邩mF܂
// param	rScreenList		XN[ꗗ(GetScreenInfo ̌)
// param	dwWidth			w̕
// param	dwHeight		w̍
// param	dwRGBBitCount	w̃rbgsNZ
// return	true	v
//			false	vȂ
//----
bool DirectDraw::IsScreenInfo(
	const vector<ScreenInfo>& rScreenList,
	DWORD dwWidth, DWORD dwHeight, DWORD dwRGBBitCount)
{
	vector<DirectDraw::ScreenInfo>::const_iterator it = rScreenList.begin();
	for(; it != rScreenList.end(); ++it)
	{
		//Debug::Trace("W:%d, H:%d, B:%d\n", it->dwWidth, it->dwHeight, it->dwRGBBitCount);

		if(
			(dwWidth == it->dwWidth) &&
			(it->dwHeight == dwHeight) &&
			(it->dwRGBBitCount == dwRGBBitCount)
		)
		{
			return true;
		}
	}
	return false;
}

//----
// XN[񂪈v邩mF܂
// param	dwWidth			w̕
// param	dwHeight		w̍
// param	dwRGBBitCount	w̃rbgsNZ
// return	true	v
//			false	vȂ
//----
bool DirectDraw::IsScreenInfo(DWORD dwWidth, DWORD dwHeight, DWORD dwRGBBitCount)
{
	return IsScreenInfo(GetScreenInfo(), dwWidth, dwHeight, dwRGBBitCount);
}

//----
// s܂
// param	hWnd			sEBhEnh
// param	rScreenInfo		XN[
// param	rOffScreenInfo	ItXN[
// param	bFullScreen		tXN[[h
// return	ʃR[h(DirectDraw ̖߂l)
//----
HRESULT DirectDraw::Initialize(
	HWND hWnd,
	const ScreenInfo& rScreenInfo,
	const ScreenInfo& rOffScreenInfo,
	bool bFullScreen)
{
	HRESULT hResult;

	// XN[̃TCYێ܂
	m_ScreenInfo = rScreenInfo;
	// ItXN[̃TCYێ܂
	m_OffScreenInfo = rOffScreenInfo;
	// tXN[̃[hێ܂
	m_bFullScreen = bFullScreen;

	// DirectDraw CX^X𐶐܂
	hResult = ::DirectDrawCreateEx(NULL, (LPVOID*)&m_pDD, IID_IDirectDraw7, NULL);
	if(hResult != DD_OK)
	{
		return hResult;
	}

	// tXN[
	if(bFullScreen == true)
	{
		// [hݒ肵܂
		hResult = m_pDD->SetCooperativeLevel(hWnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN);
		if(hResult != DD_OK)
		{
			Release();
			return hResult;
		}

		// XN[TCYݒ肵܂
		hResult = m_pDD->SetDisplayMode(
			m_ScreenInfo.dwWidth,
			m_ScreenInfo.dwHeight,
			m_ScreenInfo.dwRGBBitCount,
			0, 0);
		if(hResult != DD_OK)
		{
			Release();
			return hResult;
		}
	}
	// EBhE[h
	else
	{
		// [hݒ肵܂
		hResult = m_pDD->SetCooperativeLevel(hWnd, DDSCL_NORMAL);
		if(hResult != DD_OK)
		{
			Release();
			return hResult;
		}
	}

	// vC}T[tFX쐬܂
	DDSURFACEDESC2 DDSD;
	ZeroMemory(&DDSD, sizeof(DDSD));
	DDSD.dwSize = sizeof(DDSD);
	DDSD.dwFlags = DDSD_CAPS;
	DDSD.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
	// tXN[
	if(bFullScreen == true)
	{
		DDSD.dwFlags |= DDSD_BACKBUFFERCOUNT;
		DDSD.ddsCaps.dwCaps |= DDSCAPS_FLIP | DDSCAPS_COMPLEX;
		DDSD.dwBackBufferCount = 1;
	}

	// vC}obt@쐬܂
	hResult = m_pDD->CreateSurface(&DDSD, &m_pDDSPrimary, NULL);
	if(hResult != DD_OK)
	{
		Release();
		return hResult;
	}
	m_Primary.Attach(m_pDDSPrimary);

	// tXN[
	if(bFullScreen == true)
	{
		// obNT[tFX쐬܂
		DDSCAPS2 DDSDCAPS;
		ZeroMemory(&DDSDCAPS, sizeof(DDSDCAPS));
		DDSDCAPS.dwCaps = DDSCAPS_BACKBUFFER;
		hResult = m_pDDSPrimary->GetAttachedSurface(&DDSDCAPS, &m_pDDSBack);

		if(hResult != DD_OK)
		{
			Release();
			return hResult;
		}
		m_Back.Attach(m_pDDSBack);
	}
	// EBhE
	else
	{
		// vC}T[tFXɃNbp[쐬܂
		hResult = CreateClipper(hWnd, m_pDDSPrimary, &m_pDDPrimaryClipper);
		if(hResult != DD_OK)
		{
			Release();
			return hResult;
		}
	}

	// ItXN[T[tFX쐬܂
	// ̗̈TCY͉ʂɉf̈傫A
	// m_OffScreenRange ̑傫͂ݏoĂ܂(ONbsÔ)
	ZeroMemory(&DDSD, sizeof(DDSD));
	DDSD.dwSize = sizeof(DDSD);
	DDSD.dwFlags = DDSD_CAPS| DDSD_WIDTH | DDSD_HEIGHT;
	DDSD.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
	DDSD.dwWidth = m_OffScreenInfo.dwWidth + m_OffScreenRange.m_Width * 2;
	DDSD.dwHeight = m_OffScreenInfo.dwHeight + m_OffScreenRange.m_Height * 2;
	hResult = m_pDD->CreateSurface(&DDSD, &m_pDDSOffScreen, NULL);
	if(hResult != DD_OK)
	{
		Release();
		return hResult;
	}
	m_OffScreen.Attach(m_pDDSOffScreen);

	// EBhEێ܂
	m_hWnd = hWnd;

	return DD_OK;
}

//----
// s܂
// return	true	I
//			false	ُI
//----
bool DirectDraw::Release()
{
	// R[h}Nɂ܂傤

	// ItXN[T[tFX܂
	m_OffScreen.Release();
	m_pDDSOffScreen = NULL;

	// obNT[tFX܂
	m_Back.Release();
	m_pDDSBack = NULL;

	// vC}T[tFX܂
	m_Primary.Release();
	m_pDDSPrimary = NULL;

	// Nbp[܂
	if(m_pDDPrimaryClipper != NULL)
	{
		m_pDDPrimaryClipper->Release();
		m_pDDPrimaryClipper = NULL;
	}

	// DirectDraw CX^X܂
	if(m_pDD != NULL)
	{
		// XN[ɖ߂܂
		m_pDD->RestoreDisplayMode();
		m_pDD->SetCooperativeLevel(m_hWnd, DDSCL_NORMAL);

		m_pDD->Release();
		m_pDD = NULL;
	}

	m_hWnd = NULL;

	return true;
}

//----
// rbg}bv[h܂
// param	pFileName	t@C
// return	NULL ȊO	rbg}bṽT[tFX
//			NULL		ُI
//----
LPDIRECTDRAWSURFACE7 DirectDraw::LoadBitmapTiny(const char* pFileName)
{
	if(m_pDD == NULL)
	{
		return NULL;
	}
	return ::DDLoadBitmap(m_pDD, pFileName, 0, 0);
}

//----
// rbg}bv[h܂
// param	pFileName	t@C
// return	NULL ȊO	rbg}bṽT[tFX
//			NULL		ُI
// remarks	PNG ǂ߂܂
//----
#include "Global.h"
#include <tchar.h>
#include <locale.h>
#include <gdiplus.h>
using namespace Gdiplus;
LPDIRECTDRAWSURFACE7 DirectDraw::LoadBitmap(const char* pFileName)
{
	if(m_pDD == NULL)
	{
		return NULL;
	}

	// 摜t@Cǂݍ݂܂
	// Unicode ɕϊ܂
	// (P[ݒ肵Ȃƕϊ܂sȂ̂Œ)
	size_t uNameSize = 0;
	WCHAR wFileName[_MAX_PATH * 2];
	_tsetlocale(LC_ALL, _T(""));
	if(mbstowcs_s(&uNameSize, wFileName, strlen(pFileName) + 1, pFileName, _TRUNCATE) != 0)
	{
		return NULL;
	}

	// GDI+ ̃rbg}bv擾܂
	Bitmap* pBitmap = Bitmap::FromFile(wFileName);
	#pragma warning(disable: 4482) // ȂI
	if(pBitmap->GetLastStatus() != Status::Ok)
	{
		return NULL;
	}
	Color color;
	pBitmap->GetPixel(0, 0, &color);
	HBITMAP hbm = NULL;
	if(pBitmap->GetHBITMAP(color, &hbm) != Status::Ok)
	{
		return NULL;
	}

	//  ddutil.cpp Ɠ
	DDSURFACEDESC2          ddsd;
	IDirectDrawSurface7    *pdds;

	// Get size of the bitmap
	BITMAP bm;
	GetObject(hbm, sizeof(bm), &bm);
	// Create a DirectDrawSurface for this bitmap
	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH;
	ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
	ddsd.dwWidth = bm.bmWidth;
	ddsd.dwHeight = bm.bmHeight;
	if (m_pDD->CreateSurface(&ddsd, &pdds, NULL) != DD_OK)
	{
		return NULL;
	}
	DDCopyBitmap(pdds, hbm, 0, 0, 0, 0);
	DeleteObject(hbm);

	return pdds;
}

//----
// rbg}bv[h܂
// param	pFileName	t@C
// param	ColorKey	J[L[̐F
// return	NULL ȊO	rbg}bṽT[tFX
//			NULL		ُI
//----
LPDIRECTDRAWSURFACE7 DirectDraw::LoadBitmap(const char* pFileName, COLORREF ColorKey)
{
	LPDIRECTDRAWSURFACE7 pSurfece = LoadBitmap(pFileName);
	if(pSurfece == NULL)
	{
		return NULL;
	}
	if(SetColorKey(pSurfece, ColorKey) != DD_OK)
	{
		pSurfece->Release();
		return NULL;
	}
	return pSurfece;
}

//----
// ߐFݒ肵܂
// param	pSurface	T[tFX
// param	Color		ߐF̐F
// return	ʃR[h(DirectDraw ̖߂l)
//----
HRESULT DirectDraw::SetColorKey(LPDIRECTDRAWSURFACE7 pSurface, COLORREF Color)
{
	return DDSetColorKey(pSurface, Color);
}

// Nbp[𐶐܂
HRESULT DirectDraw::CreateClipper(
	HWND hWnd, LPDIRECTDRAWSURFACE7 pSurface,
	LPDIRECTDRAWCLIPPER* pClipper)
{
	// Nbp[쐬܂
	HRESULT hResult = m_pDD->CreateClipper(0, pClipper, NULL);
	if(hResult != DD_OK)
	{
		return hResult;
	}

	hResult = (*pClipper)->SetHWnd(0, hWnd);
	if(hResult != DD_OK)
	{
		return hResult;
	}

	hResult = pSurface->SetClipper(*pClipper);
	if(hResult != DD_OK)
	{
		return hResult;
	}

	return hResult;
}
