#pragma once

#include <vector>
#include <ddraw.h>
#define DIRECTINPUT_VERSION 0x0800		// ȂI
#include "Texture.h"
#include "Size.h"

using namespace std;

//----
// DirectDraw
//----
class DirectDraw
{
public:
	// XN[̉𑜓x`
	typedef struct
	{
		// 
		DWORD dwWidth;
		// 
		DWORD dwHeight;
		// rbgsNZ
		DWORD dwRGBBitCount;
	} ScreenInfo;

public:
	// A^b`EBhEnh
	HWND m_hWnd;
	// XN[
	ScreenInfo m_ScreenInfo;
	// tXN[
	bool m_bFullScreen;
	// DirectDraw IuWFNg
	LPDIRECTDRAW7 m_pDD;
	// DirectDraw vC}T[tFX
	LPDIRECTDRAWSURFACE7 m_pDDSPrimary;
	// DirectDraw obNT[tFX
	LPDIRECTDRAWSURFACE7 m_pDDSBack;
	// DirectDraw ItXN[T[tFX
	LPDIRECTDRAWSURFACE7 m_pDDSOffScreen;
	// DirectDraw vC}T[tFXNbp[IuWFNg
	LPDIRECTDRAWCLIPPER m_pDDPrimaryClipper;
	// ItXN[
	ScreenInfo m_OffScreenInfo;
	// ItXN[̋ë
	SizeI m_OffScreenRange;

	//----
	// A^b`T[tFX
	//----
	// vC}
	Texture m_Primary;
	// obN
	Texture m_Back;
	// ItXN[
	Texture m_OffScreen;

public:
	// RXgN^
	DirectDraw();
	// fXgN^
	virtual ~DirectDraw();
	// XN[擾܂
	static vector<ScreenInfo> GetScreenInfo();
	// XN[񂪈v邩mF܂
	static bool IsScreenInfo(
		const vector<ScreenInfo>& rScreenList,
		DWORD dwWidth, DWORD dwHeight, DWORD dwRGBBitCount);
	static bool IsScreenInfo(DWORD dwWidth, DWORD dwHeight, DWORD dwRGBBitCount);
	// s܂
	HRESULT Initialize(
		HWND hWnd,
		const ScreenInfo& rScreenInfo,
		const ScreenInfo& rOffScreenInfo,
		bool bFullScreen);
	// s܂
	bool Release();
	// rbg}bv[h܂
	LPDIRECTDRAWSURFACE7 LoadBitmapTiny(const char* pFileName);
	LPDIRECTDRAWSURFACE7 LoadBitmap(const char* pFileName);
	LPDIRECTDRAWSURFACE7 LoadBitmap(const char* pFileName, COLORREF ColorKey);
	// ߐFݒ肵܂
	HRESULT SetColorKey(COLORREF Color);
	HRESULT SetColorKey(LPDIRECTDRAWSURFACE7 pSurface, COLORREF Color);

private:
	// Nbp[𐶐܂
	HRESULT CreateClipper(
		HWND hWnd, LPDIRECTDRAWSURFACE7 pSurface,
		LPDIRECTDRAWCLIPPER* pClipper);
};
