#include "stdafx.h"
#include "Global.h"
#include "ImageTool.h"
#include "SystemTool.h"

// test
//#include "TestCharacterTask.h"
#include "PlayerTask.h"

//----
// RXgN^
//----
Global::Global() :
	// XN[
	  m_ScreenInfo()
	// ItXN[
	, m_OffScreenInfo()
	// t[[g
	, m_dwFrameRate(1000 / 60)
	// XgG[
	, m_dwLastError(0)
{
}

//----
// fXgN^
//----
Global::~Global()
{
	// s܂
	Release();
}

//----
// s܂
// param	hWnd			sEBhEnh
// param	rScreenInfo		XN[
// param	rOffScreenInfo	ItXN[
// param	bFullScreen		tXN[[h
// return	IR[h
//			1	I
//			-1	𑜓xG[
//			-2	DirectDraw G[
//			-3	vOpX擾G[
//			-4	摜c[G[
//			-5	͏G[
//			-6	G[
// remarks	ُI̍ۂɂ m_dwLastError ɃG[񂪓ꍇ܂
//----
int Global::Initialize(
	HWND hWnd,
	const DirectDraw::ScreenInfo& rScreenInfo,
	const DirectDraw::ScreenInfo& rOffScreenInfo,
	bool bFullScreen)
{
	// w̃XN[[h݂邩mF܂
	if(DirectDraw::IsScreenInfo(
		rScreenInfo.dwWidth, rScreenInfo.dwHeight,
		rScreenInfo.dwRGBBitCount) == false)
	{
		return -1;
	}

	// DierctX ܂
	HRESULT hResult = m_DirectDraw.Initialize(
		hWnd, rScreenInfo, rOffScreenInfo, bFullScreen);
	if(hResult != DD_OK)
	{
		m_dwLastError = hResult;
		return -2;
	}

	// vÕpX擾܂
	char ProgramPath[_MAX_PATH];
	if(SystemTool::GetProgramPath(ProgramPath, sizeof(ProgramPath) - 1) == false)
	{
		return -3;
	}

	// 摜c[̏s܂
	if(m_ImageTool.Initialize() == false)
	{
		return -4;
	}

	// 摜̃pXݒ肵܂
	char ImagePath[_MAX_PATH];
	wsprintf(ImagePath, "%sResource\\", ProgramPath);
	m_ImageTool.SetImagePath(ImagePath);

	// J[L[ݒ肵܂
	m_ImageTool.m_ColorKey = RGB(0, 255, 0);

	// ^XNǗɕ`ǗA^b`܂
	m_TaskManager.m_pDrawManager = &m_DrawManager;

	// ͏̏s܂
	if(m_InputManager.Initialize() == false)
	{
		return -5;
	}

	// ̃pX߂܂
	char SoundPath[_MAX_PATH];
	wsprintf(SoundPath, "%sResource\\", ProgramPath);

	// ̏s܂
	if(m_SoundManager.Initialize(SoundPath) == false)
	{
		return -6;
	}

	// Ƃ肠Q[SẲɐݒ肷ƂĐ݌v܂
	m_SoundManager.Add(SoundID::ShipMissile, SoundType::SE, SoundDataFormatType::WAV, "ShipMissile.wav");
	m_SoundManager.Add(SoundID::BGM1, SoundType::BGM, SoundDataFormatType::MIDI, "BGM1.midi", -1);

	//DWORD dwLength = m_SoundManager.GetMediaLength(SoundID::BGM1);
	//map<int, SoundItem>::iterator it = m_SoundManager.find(SoundID::BGM1);
	//it->second.m_lEndSeekPoint = dwLength - 10;

	// BGM 炵܂
    g_Global.m_SoundManager.Play(SoundID::BGM1, -1);

	// @^XNo^܂
	PlayerTask* pPlayer = new PlayerTask();
	m_TaskManager.Add(pPlayer);
	pPlayer->SetCoordinate(16, 112);

	return 1;
}

//----
// s܂
// return	true	I
//			false	ُI
//----
bool Global::Release()
{
	// Ɉُ킪mFtO
	bool bResult = true;

	// ^XNǗ̉s܂
	m_TaskManager.Release();

	// DirectDraw ̉s܂
	if(m_DirectDraw.Release() == false)
	{
		bResult = false;
	}

	// ̉c

	return bResult;
}

//----
// Q[̎ss܂
// return	1	𑱍s
//			0	I
//			-1	ُI
//----
int Global::Execute()
{
	// ͏s܂
	m_InputManager.Execute();

	// ^XNǗs܂
	m_TaskManager.Execute();

	// ^XN̕`s܂
	m_DrawManager.Draw();

	// IƔf 0 Ԃ܂
	if(m_InputManager.IsKeyDown(0, Controller::FORCE_EXIT) == true)
	{
		return 0;
	}

	return 1;
}
