#include "stdafx.h"
#include <vector>
#include "IniFile.h"
#include "SystemTool.h"
#include "StringTool.h"

// e
static const char* const INI_FILE_NAME = "SampleActionGame.ini";
static const char* const APP_DISPLAY = "Display";
static const char* const KEY_FULLSCREEN = "FullScreen";
static const char* const KEY_SCREENSIZE = "ScreenSize";

//----
// INI t@C擾܂
// param	pPathBuffer		擾t@Cz
// param	uBufferSize		t@Cz̃TCY
// return	true	I
//			false	ُI
//----
bool IniFile::GetIniFileName(char* pPathBuffer, size_t uBufferSize)
{
	// vOpX擾܂
	char ProgaramPath[_MAX_PATH];
	if(SystemTool::GetProgramPath(ProgaramPath, sizeof(ProgaramPath) - 1) == false)
	{
		return false;
	}

	sprintf_s(pPathBuffer, uBufferSize, "%s%s", ProgaramPath, INI_FILE_NAME);

	return true;
}

//----
// tXN[[h擾܂
// return	true	ON
//			false	OFF
//----
bool IniFile::GetFullScreen()
{
	char IniFileName[_MAX_PATH];
	GetIniFileName(IniFileName, sizeof(IniFileName) - 1);
	return GetPrivateProfileInt(APP_DISPLAY, KEY_FULLSCREEN, 0, IniFileName) ? true : false;
}

//----
// XN[̃TCY擾܂
// return	rdwWidth		擾镝
//			rdwHeight	擾鍂
//----
void IniFile::GetScreenSize(DWORD& rdwWidth, DWORD& rdwHeight)
{
	// ftHgݒ肵܂
	rdwWidth = 800;
	rdwHeight = 600;

	char IniFileName[_MAX_PATH];
	GetIniFileName(IniFileName, sizeof(IniFileName) - 1);

	char ReadBuffer[4096];
	GetPrivateProfileString(
		APP_DISPLAY, KEY_SCREENSIZE, "",
		ReadBuffer, sizeof(ReadBuffer) - 1, IniFileName);
	if(strlen(ReadBuffer) == 0)
	{
		return;
	}

	vector<string> Params;
	StringTool::GetParameterByComma(ReadBuffer, Params);
	if(Params.size() == 2)
	{
		rdwWidth = atoi(Params[0].c_str());
		rdwHeight = atoi(Params[1].c_str());
	}
	return;
}
