#include "stdafx.h"
#include <windows.h>
#include <tchar.h>
#include "Resource.h"
#include "Global.h"
#include "IniFile.h"
#include "InputManager.h"

// CX^X
static const char* const g_pProgramName = "SampleActionGame";

// CX^Xnh
HINSTANCE g_hInstance;
// NX
static const char* const g_pClassName = "SampleActionGame";
// EBhEnh
HWND g_hGameWindow;
// O[oIuWFNg
Global g_Global;

//----
// Q[EBhẼEBhEvV[W
// param	hWnd		EBhE
// param	uMessage		bZ[W
// param	wParam		1
// param	lParam		2
// return	bZ[W̌
//----
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
	switch(uMessage)
	{
		// EBhE
		case WM_CREATE:
		{
			// tXN[擾܂
			bool bFullScreen = IniFile::GetFullScreen();

			// VXe܂
			int nResult = g_Global.Initialize(
				hWnd,
				g_Global.m_ScreenInfo,
				g_Global.m_OffScreenInfo,
				bFullScreen);
			if(nResult != 1)
			{
				// G[R[hɂU蕪܂
				char Message[256];
				if(nResult == -1)
				{
					DirectDraw::ScreenInfo& rInfo = g_Global.m_ScreenInfo;
					wsprintf(Message,
						"w̉𑜓xɐݒł܂B[%d, %d, %d]",
						rInfo.dwWidth, rInfo.dwHeight, rInfo.dwRGBBitCount);
				}
				else if(nResult == -2)
				{
					wsprintf(Message, "DirectDraw̏Ɏs܂B[%d]", g_Global.m_dwLastError);
				}
				else
				{
					wsprintf(Message, "ɂĒvIȃG[܂B");
				}
				MessageBox(hWnd , Message, g_pProgramName, MB_OK);
				PostQuitMessage(0);
				break;
			}
			ShowCursor(FALSE);
			break;
		}

		// EBhEj
		case WM_DESTROY:
			// O[oIuWFNg܂
			g_Global.Release();
			PostQuitMessage(0);
			break;
		// ftHg
		default:
			return DefWindowProc(hWnd, uMessage, wParam, lParam);
	}

	return 0;
}

//----
// Q[EBhE̍W𒆉ɐݒ肵܂
// param	hWnd		EBhE
//----
void SetGameWindowCenterPosition(HWND hWnd)
{
	// ʂ̑傫擾
	int nScreenX = GetSystemMetrics(SM_CXSCREEN);
	int nScreenY = 	GetSystemMetrics(SM_CYSCREEN);

	RECT WindowRect;
	GetWindowRect(hWnd, &WindowRect);
	int nWidth = WindowRect.right - WindowRect.left;
	int nHeight = WindowRect.bottom - WindowRect.top;

	// XN[ɐݒ肵܂
	int x = (nScreenX - nWidth) / 2;
	int y = (nScreenY - nHeight) / 2;
	SetWindowPos(hWnd, NULL, x, y, nWidth, nHeight, SWP_SHOWWINDOW);
}

//----
// EBhEo^܂
// param	hInstance	CX^Xnh
// return	true		I
//			false		ُI
//----
bool RegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;
	wcex.cbSize = sizeof(wcex);
	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDC_SAMPLE_ICON));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= g_pClassName;
	wcex.hIconSm		= LoadIcon(hInstance, MAKEINTRESOURCE(IDC_SAMPLE_ICON_SMALL));
	if(RegisterClassEx(&wcex) == 0)
	{
		return false;
	}
	return true;
}

//----
// Q[pEBhE쐬܂
// param	hInstance		CX^Xnh
// param	nCmdShow		\tO
// param	dwWidth			XN[
// param	dwHeight		XN[
// return	NULL ȊO	EBhEnh
//			NULL		ُI
//----
HWND CreateGameWindow(
	HINSTANCE hInstance, int nCmdShow,
	DWORD dwWidth, DWORD dwHeight)
{
	// Lk\ɂ͂܂
	DWORD dwStyle = WS_OVERLAPPEDWINDOW;
	dwStyle &= ~WS_THICKFRAME;

	// NCAg̈悩K؂ȃEBhETCY߂܂
	RECT ClientRect;
	ClientRect.left = ClientRect.top = 0;
	ClientRect.right = dwWidth;
	ClientRect.bottom = dwHeight;
	AdjustWindowRect(&ClientRect, dwStyle, FALSE);

	// EBhE𐶐܂
	HWND hWnd = CreateWindow(
		g_pClassName, "SampleActionGame", dwStyle,
		CW_USEDEFAULT, 0,
		ClientRect.right - ClientRect.left,
		ClientRect.bottom - ClientRect.top,
		NULL, NULL, hInstance, NULL);
   if(hWnd == NULL)
   {
		return NULL;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return hWnd;
}

//----
// Gg|Cg
// param	hInstance		CX^Xnh
// param	hPrevInstance	gp(16Bit Av̖c)
// param	lpCmdLine		R}hC
// param	nCmdShow		\tO
// return	0 ȊO	I
//			0		ُI
//----
int APIENTRY _tWinMain(
	 HINSTANCE hInstance,
	 HINSTANCE,
	 LPTSTR,
	 int nCmdShow)
{
	// O[onh}܂
	g_hInstance = hInstance;

	if(RegisterClass(hInstance) == 0)
	{
		MessageBox(NULL, "RegisterClass Failed.", g_pProgramName, (MB_OK | MB_ICONSTOP));
		return 0;
	}

	// XN[ݒ肵܂

	IniFile::GetScreenSize(
		g_Global.m_ScreenInfo.dwWidth,
		g_Global.m_ScreenInfo.dwHeight);
	g_Global.m_ScreenInfo.dwRGBBitCount = 32;

	// ItXN[ݒ肵܂
	g_Global.m_OffScreenInfo.dwWidth = 256;
	g_Global.m_OffScreenInfo.dwHeight = 240;

	// EBhE쐬܂
	g_hGameWindow = CreateGameWindow(
		hInstance, nCmdShow,
		g_Global.m_ScreenInfo.dwWidth,
		g_Global.m_ScreenInfo.dwHeight);
	if(g_hGameWindow == NULL)
	{
		MessageBox(NULL, "CreateGameWindow Failed.", g_pProgramName, (MB_OK | MB_ICONSTOP));
		return 0;
	}

	// EBhËʒu𒆉ɐݒ肵܂
	SetGameWindowCenterPosition(g_hGameWindow);

	// bZ[W[v
	timeBeginPeriod(1);
	// ̍XV^C~Oݒ肵܂
	DWORD dwTime = timeGetTime() + g_Global.m_dwFrameRate;
	for(;;)
	{
		// Windows ̃bZ[WmF܂
		MSG message;
		if(PeekMessage(&message, NULL, 0, 0, PM_NOREMOVE) != 0)
		{
			// WM_QUIT ł邩mF܂
			if(GetMessage(&message, NULL, 0, 0) == 0)
			{
				break;
			}
			// bZ[Wϊs܂
			TranslateMessage(&message);
			DispatchMessage(&message);
		}
		else
		{
			// IĂ̂ŐQ܂
			if(dwTime > timeGetTime())
			{
				Sleep(1);
				continue;
			}

			// ̎Ԃݒ肵܂
			dwTime = timeGetTime() + g_Global.m_dwFrameRate;

			// Q[̏
			if(g_Global.Execute() == 0)
			{
				PostQuitMessage(1);
			}
		}
	}
	::timeEndPeriod(1);

	return 1;
}
