#include "stdafx.h"
#include "SoundDeviceBase.h"

// Ƃ肠 MCI yȂ̂ MCI ł̃NXւ
// DȃI[fBIGW
#include <mmsystem.h>

// pXbh
DWORD WINAPI SoundThread(LPVOID lpParameter);

//----
// RXgN^
//----
SoundDeviceBase::SoundDeviceBase() :
	// ʒmEBhE
	  m_hNotifyWindow(NULL)
	// Xbhnh
	, m_hSoundThread(NULL)
	// XbhItO
	, m_bSoundThreadThreadTerminate(false)
{
	// NGXgzr
	ZeroMemory(&m_RequestLock, sizeof(m_RequestLock));
}

//----
// fXgN^
//----
SoundDeviceBase::~SoundDeviceBase()
{
	// Xbh܂
	if(m_hSoundThread != NULL)
	{
		m_bSoundThreadThreadTerminate = true;
		WaitForSingleObject(m_hSoundThread, 1000);
	}

	// NeBJZNV܂
	DeleteCriticalSection(&m_RequestLock);
}

//----
// Q[EBhẼEBhEvV[W
// param	hWnd		EBhE
// param	uMessage		bZ[W
// param	wParam		1
// param	lParam		2
// return	bZ[W̌
//----
LRESULT CALLBACK SoundWindowProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
	switch(uMessage)
	{
		// MCI Cxg
		case MM_MCINOTIFY:
		{
			// EBhEɓo^ĂGW擾܂
			SoundDeviceBase* pEngine = (SoundDeviceBase*)(LongToPtr(
				GetWindowLongPtr(hWnd, GWLP_USERDATA)));
			// ʒm܂
			pEngine->OnMCINotify(wParam, lParam);
			break;
		}

		// ftHg
		default:
			return DefWindowProc(hWnd, uMessage, wParam, lParam);
	}

	return 0;
}

//----
// s܂
// return	true	I
//			false	ُI
//----
bool SoundDeviceBase::Initialize()
{
	// NGXgzr
	InitializeCriticalSection(&m_RequestLock);

	// pXbh𐶐܂
	DWORD dwThreadID;
	m_hSoundThread = CreateThread(NULL, 0, SoundThread, this, 0, &dwThreadID);
	if(m_hSoundThread == NULL)
	{
		return false;
	}

	return true;
}

//----
// fBÃTCY擾܂
// param	pFileName	TEht@C
// param	dwLength	߂lƂȂ郁fBATCY
// return	true	I
//			false	ُI
//----
bool SoundDeviceBase::GetMediaLength(const char* pFileName, DWORD& dwLength) const
{
	dwLength = 0;

	MCIERROR Result;

	// Open
	MCI_OPEN_PARMS OpenParams;
	ZeroMemory(&OpenParams, sizeof(OpenParams));
	OpenParams.lpstrElementName = pFileName;
	OpenParams.lpstrDeviceType = GetDeviceType();
	Result = mciSendCommand(0, MCI_OPEN, MCI_OPEN_TYPE | MCI_OPEN_ELEMENT, (DWORD_PTR)&OpenParams);
	if(Result != 0)
	{
		//Debug::Trace("Type:%s, DeviceID:%d\n", OpenParams.lpstrDeviceType, OpenParams.wDeviceID);
		//char Message[512];
		//mciGetErrorString(Result, Message, sizeof(Message) - 1);
		return false;
	}

	// Ԃ̃tH[}bg~bɂ܂
	MCI_SEQ_SET_PARMS SetParams;
	SetParams.dwTimeFormat = MCI_FORMAT_MILLISECONDS;
	Result = mciSendCommand(
		OpenParams.wDeviceID, MCI_SET, MCI_WAIT | MCI_SET_TIME_FORMAT, (DWORD_PTR)&SetParams);
	if(Result != 0)
	{
		return false;
	}

	// Length
	MCI_STATUS_PARMS StatusParams;
	StatusParams.dwItem = MCI_STATUS_LENGTH;
	Result = mciSendCommand(
		OpenParams.wDeviceID,
		MCI_STATUS, MCI_WAIT | MCI_STATUS_ITEM,
		(DWORD_PTR)&StatusParams);
	if(Result != 0)
	{
		return false;
	}

	dwLength = (DWORD)StatusParams.dwReturn;

	// Close
	MCI_GENERIC_PARMS GenericParams;
	mciSendCommand(OpenParams.wDeviceID, MCI_CLOSE, 0, (DWORD_PTR)&GenericParams);

	return true;
}

//----
// NGXg𔭍s܂
// param	nCommand	R}h(SoundDeviceCommand::*)
// param	rItem		TEh
//----
void SoundDeviceBase::Add(int nCommand, const SoundItem& rItem)
{
	// rŔzɓo^܂
	EnterCriticalSection(&m_RequestLock);

	// NGXgz𑖍Ċɂ邩mF܂
	// ɂꍇ͂̍ڂ̃R}hύXs܂
	bool bHit = false;
	vector<SoundDeviceItem>::iterator it = m_Resuest.begin();
	for(; it != m_Resuest.end(); ++it)
	{
		if(it->m_nID == rItem.m_nID)
		{
			bHit = true;
			break;
		}
	}

	// R}hύX
	if(bHit == true)
	{
		it->m_nCommand = nCommand;
	}
	// VKo^
	else
	{
		SoundDeviceItem DItem(nCommand, rItem);
		m_Resuest.push_back(DItem);
	}

	LeaveCriticalSection(&m_RequestLock);
}

//----
// ݔĂ邩mF܂
// param	rItem	TEh
// return	true	
//			false	ĂȂ
//----
bool SoundDeviceBase::IsPlaying(const SoundDeviceItem& rItem) const
{
	if(rItem.m_DeviceID == 0xFFFFFFFF)
	{
		return false;
	}

	// 󋵂擾܂
	MCI_STATUS_PARMS StatusParams;
	StatusParams.dwItem = MCI_STATUS_MODE;
	MCIERROR Result = mciSendCommand(rItem.m_DeviceID, MCI_STATUS, MCI_STATUS_ITEM, (DWORD_PTR)&StatusParams);
	if(Result == 0)
	{
		// Đ
		if(StatusParams.dwReturn == MCI_MODE_PLAY)
		{
			return true;
		}
	}
	return false;
}

//----
// Đ܂
// param	rItem	TEh
//----
void SoundDeviceBase::Play(SoundDeviceItem& rItem)
{
	// R}hāAԂĐ
	rItem.m_nCommand = SoundDeviceCommand::Finished;
	rItem.m_nStatus = 1;

	MCIERROR Result;
	//char Message[512];

	// foCXJĂȂΊJ܂
	if(rItem.m_DeviceID == 0xFFFFFFFF)
	{
		// Open
		MCI_OPEN_PARMS OpenParams;
		ZeroMemory(&OpenParams, sizeof(OpenParams));
		OpenParams.lpstrElementName = rItem.m_FileName.c_str();
		OpenParams.lpstrDeviceType = GetDeviceType();
		Result = mciSendCommand(0, MCI_OPEN, MCI_OPEN_TYPE | MCI_OPEN_ELEMENT, (DWORD_PTR)&OpenParams);

		//Debug::Trace("Type:%s, DeviceID:%d\n", OpenParams.lpstrDeviceType, OpenParams.wDeviceID);
		//mciGetErrorString(Result, Message, sizeof(Message) - 1);

		// foCX ID ݒ肵܂
		rItem.m_DeviceID = OpenParams.wDeviceID;

		// Ԃ̃tH[}bg~bɂ܂
		MCI_SEQ_SET_PARMS SetParams;
		SetParams.dwTimeFormat = MCI_FORMAT_MILLISECONDS;
		Result = mciSendCommand(
			rItem.m_DeviceID, MCI_SET, MCI_WAIT | MCI_SET_TIME_FORMAT, (DWORD_PTR)&SetParams);
	}

	// Play
	MCI_PLAY_PARMS PlayParams;
	PlayParams.dwCallback = (DWORD_PTR)m_hNotifyWindow;
	PlayParams.dwFrom = rItem.m_lStartSeekPoint;
	DWORD dwParam1 = MCI_NOTIFY | MCI_FROM;
	if(rItem.m_lEndSeekPoint != -1)
	{
		dwParam1 |= MCI_TO;
		PlayParams.dwTo = rItem.m_lEndSeekPoint;
	}
	Result = mciSendCommand(rItem.m_DeviceID, MCI_PLAY, dwParam1, (DWORD_PTR)&PlayParams);

	//mciGetErrorString(Result, Message, sizeof(Message) - 1);
	//Debug::Trace("%s\n", Message);
}

//----
// ~܂
// param	rItem	TEh
//----
void SoundDeviceBase::Stop(SoundDeviceItem& rItem)
{
	// UfoCX܂
	Close(rItem);

	// R}hāAԂ~
	rItem.m_nCommand = SoundDeviceCommand::Finished;
	rItem.m_nStatus = 0;

	if(rItem.m_DeviceID == 0xFFFFFFFF)
	{
		return;
	}

	MCI_GENERIC_PARMS GenericParams;
	mciSendCommand(rItem.m_DeviceID, MCI_STOP, 0, (DWORD_PTR)&GenericParams);

	rItem.m_DeviceID = 0xFFFFFFFF;
}

//----
// ꎞ~܂
// param	rItem	TEh
//----
void SoundDeviceBase::Pause(SoundDeviceItem& rItem)
{
	// R}hāAԂꎞ~
	rItem.m_nCommand = SoundDeviceCommand::Finished;
	rItem.m_nStatus = 2;

	// T|[g
	// MCI_PAUSE, MCI_RESUME
}

//----
// ܂
// param	rItem	TEh
//----
void SoundDeviceBase::Close(SoundDeviceItem& rItem)
{
	if(rItem.m_DeviceID == 0xFFFFFFFF)
	{
		return;
	}

	MCI_GENERIC_PARMS GenericParams;
	mciSendCommand(rItem.m_DeviceID, MCI_CLOSE, 0, (DWORD_PTR)&GenericParams);
}

//----
// MM_MCINOTIFY ʒmCxg
// param	wParam	ʒmR[h (MCI_NOTIFY_*)
// param	lParam	foCX ID
//----
void SoundDeviceBase::OnMCINotify(WPARAM wParam, LPARAM lParam)
{
	//Debug::Trace("OnMCINotify [%d, %d]\n", wParam, lParam);

	if(wParam != MCI_NOTIFY_SUCCESSFUL)
	{
		return;
	}

	//----
	// ̏
	//----
	// r
	EnterCriticalSection(&m_RequestLock);

	// NGXgz𑖍ĈvfoCX ID ̏ύX܂
	vector<SoundDeviceItem>::iterator it = m_Resuest.begin();
	for(; it != m_Resuest.end(); ++it)
	{
		if(it->m_DeviceID == (MCIDEVICEID)lParam)
		{
			// Đ񐔂炵܂
			if(it->m_nLoopCount > 0)
			{
				// Đ񐔂ȂȂ~ɂ܂
				it->m_nPlayCount++;
				if(it->m_nPlayCount >= it->m_nLoopCount)
				{
					it->m_nCommand = SoundDeviceCommand::Stop;
				}
			}
			// 
			else if(it->m_nLoopCount <= 0)
			{
				// ĂэĐɂ܂
				//it->m_nCommand = SoundDeviceCommand::Play;
				Play(*it);
			}
		}
	}

	LeaveCriticalSection(&m_RequestLock);
}

//----
// pXbh
// param	lpParameter		TEhfoCX
// return	XbhIR[h
//----
DWORD WINAPI SoundThread(LPVOID lpParameter)
{
	SoundDeviceBase* pDevice = (SoundDeviceBase*)lpParameter;

	// MCI ʒmpEBhENXo^܂
	WNDCLASSEX WndClass;
	ZeroMemory(&WndClass, sizeof(WndClass));
	WndClass.cbSize			= sizeof(WndClass);
	WndClass.lpfnWndProc	= SoundWindowProc;
	WndClass.lpszClassName	= "SoundNotifyWindow";
	ATOM Atom = RegisterClassEx(&WndClass);
	if((Atom == 0) && (GetLastError() != ERROR_CLASS_ALREADY_EXISTS))
	{
		return 0;
	}

	// MCI ʒmpEBhE쐬܂
	pDevice->m_hNotifyWindow = CreateWindow(
		"SoundNotifyWindow", "SoundNotifyWindow", 0,
		0, 0, 0, 0, NULL, NULL, NULL, NULL);
	if(pDevice->m_hNotifyWindow == NULL)
	{
		return 0;
	}

	// EBhEɎo^Ă܂
	SetWindowLongPtr(pDevice->m_hNotifyWindow, GWLP_USERDATA, PtrToLong(pDevice));

	// I܂Ńj^[܂
	while(pDevice->m_bSoundThreadThreadTerminate == false)
	{
		// r
		EnterCriticalSection(&pDevice->m_RequestLock);

		// R}hĂs܂
		// zP[X̂ŁAt瑖܂
		int nCount = (int)pDevice->m_Resuest.size();
		for(int i = (nCount - 1); i >= 0; i--)
		{
			SoundDeviceItem& rItem = pDevice->m_Resuest[i];

			// R}hs܂
			switch(rItem.m_nCommand)
			{
				// Đ
				case SoundDeviceCommand::Play:
					pDevice->Play(rItem);
					break;
				// ~
				case SoundDeviceCommand::Stop:
					pDevice->Stop(rItem);
					// ~ēo^܂
					pDevice->m_Resuest.erase(pDevice->m_Resuest.begin() + i);
					break;
				// ꎞ~
				case SoundDeviceCommand::Pause:
					pDevice->Pause(rItem);
					break;
			}
		}

		LeaveCriticalSection(&pDevice->m_RequestLock);

		// Windows ̃bZ[WmF܂
		MSG message;
		if(PeekMessage(&message, pDevice->m_hNotifyWindow, 0, 0, PM_NOREMOVE) != 0)
		{
			if(GetMessage(&message, pDevice->m_hNotifyWindow, 0, 0) != 0)
			{
				// bZ[Wϊs܂
				TranslateMessage(&message);
				DispatchMessage(&message);
			}
		}
		else
		{
			Sleep(1);
		}
	}

	// EBhEj܂
	if(pDevice->m_hNotifyWindow != NULL)
	{
		DestroyWindow(pDevice->m_hNotifyWindow);
	}

	return 0;
}
