#pragma once

#include <vector>
#include "SoundItem.h"

using namespace std;

// TEhfoCXR}h
namespace SoundDeviceCommand
{
	enum
	{
		// Đ
		Play,
		// ꎞ~
		Pause,
		// ~
		Stop,
		// 
		Finished,
	};
}

//----
// TEhfoCX
//----
class SoundDeviceItem : public SoundItem
{
public:
	// NGXgR}h(SoundDeviceCommand::*)
	int m_nCommand;
	// foCX ID
	MCIDEVICEID m_DeviceID;
	// (0:~, 1:Đ, 2:ꎞ~)
	int m_nStatus;
	// Đ
	int m_nPlayCount;

	// RXgN^
	SoundDeviceItem(int nCommand, const SoundItem rItem) :
		  SoundItem(rItem)
		, m_nCommand(nCommand)
		, m_DeviceID(0xFFFFFFFF)
		, m_nStatus(0)
		, m_nPlayCount(0) {}
};

//----
// TEhfoCX
//----
class SoundDeviceBase
{
public:

protected:
	// ʒmEBhE
	HWND m_hNotifyWindow;
	// Xbhnh
	HANDLE m_hSoundThread;
	// XbhItO
	bool m_bSoundThreadThreadTerminate;
	// NGXgz
	vector<SoundDeviceItem> m_Resuest;
	// NGXgzr
	CRITICAL_SECTION m_RequestLock;

public:
	// RXgN^
	SoundDeviceBase();
	// RXgN^
	virtual ~SoundDeviceBase();
	// s܂
	virtual bool Initialize();
	// fBÃTCY擾܂
	bool GetMediaLength(
		const char* pFileName, DWORD& dwLength) const;

protected:
	// NGXg𔭍s܂
	virtual void Add(int nCommand, const SoundItem& rItem);
	// ݔĂ邩mF܂
	virtual bool IsPlaying(const SoundDeviceItem& rItem) const;
	// Đ܂
	virtual void Play(SoundDeviceItem& rItem);
	// ꎞ~܂
	virtual void Pause(SoundDeviceItem& rItem);
	// ~܂
	virtual void Stop(SoundDeviceItem& rItem);
	// ܂
	virtual void Close(SoundDeviceItem& rItem);
	// MM_MCINOTIFY ʒmCxg
	virtual void OnMCINotify(WPARAM wParam, LPARAM lParam);
	// foCX^Cv擾܂
	virtual const char* GetDeviceType() const {return "";}

	// R[obN֐
	friend LRESULT CALLBACK SoundWindowProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam);
	// Xbh֐
	friend DWORD WINAPI SoundThread(LPVOID lpParameter);
};
