#include "stdafx.h"
#include "SoundManager.h"

#include "SoundID.h"

//----
// RXgN^
//----
SoundManager::SoundManager() :
	// VXeƂẲ̋
	  m_bEnableSystem(true)
	// SE ̋
	, m_bEnableSE(true)
	// BGM ̋
	, m_bEnableBGM(true)
	// SE foCX
	, m_DeviceSE()
	// BGM foCX
	, m_DeviceBGM()
{
	// t@CpX
	memset(m_SoundPath, 0, sizeof(m_SoundPath));
}

//----
// fXgN^
//----
SoundManager::~SoundManager()
{
}

//----
// s܂
// param	pSoundPath		pX
// return	true	I
//			false	ُI
//----
bool SoundManager::Initialize(const char* pSoundPath)
{
	// foCX̏s܂
	//if(m_DeviceSE.Initialize(hNotifyWindow) == false)
	if(m_DeviceSE.Initialize() == false)
	{
		return false;
	}
	if(m_DeviceBGM.Initialize() == false)
	{
		return false;
	}

	// pXݒ肵܂
	SetSoundPath(pSoundPath);

	return true;
}

//----
// pXݒ肵܂
// param	pPath	pX
//----
void SoundManager::SetSoundPath(const char* pPath)
{
	wsprintf(m_SoundPath, pPath);
}

//----
// ڂǉ܂
// param	nID					ID
// param	nType				(SoundType::*)
// param	nDataFormatType		f[^tH[}bg(DataFormatType::*)
// param	FileName			t@C
//----
void SoundManager::Add(
	int nID, int nType, int nDataFormatType, string FileName)
{
	Add(nID, nType, nDataFormatType, FileName, 1, 0, -1);
}

//----
// ڂǉ܂
// param	nID					ID
// param	nType				(SoundType::*)
// param	nDataFormatType		f[^tH[}bg(DataFormatType::*)
// param	FileName			t@C
// param	nLoopCount			[v (-1Ŗ)
//----
void SoundManager::Add(
	int nID, int nType, int nDataFormatType, string FileName, int nLoopCount)
{
	Add(nID, nType, nDataFormatType, FileName, nLoopCount, 0, -1);
}

//----
// ڂǉ܂
// param	nID					ID
// param	nType				(SoundType::*)
// param	nDataFormatType		f[^tH[}bg(DataFormatType::*)
// param	FileName			t@C
// param	nLoopCount			[v (-1Ŗ)
// param	lSeekStartPoint		ĐJnV[Nʒu
// param	lSeekEndPoint		ĐIʒu (-1ōŌ܂)
//----
void SoundManager::Add(
	int nID, int nType, int nDataFormatType, string FileName,
	int nLoopCount, long lSeekStartPoint, long lSeekEndPoint)
{
	// VXeƂĉĂȂꍇ͔܂
	if(m_bEnableSystem == false)
	{
		return;
	}

	// ACeݒ肵܂
	SoundItem Item;

	// ɂ鋤ʍڂ̐ݒ
	Item.m_nID = nID;
	Item.m_nType = nType;
	Item.m_nDataFormatType = nDataFormatType;
	Item.m_FileName = m_SoundPath + FileName;
	Item.m_nLoopCount = nLoopCount;
	Item.m_lStartSeekPoint = lSeekStartPoint;
	Item.m_lEndSeekPoint = lSeekEndPoint;

	// ACeo^
	insert(make_pair(nID, Item));
}

//----
// Đ܂
// param	nID		 ID
//----
void SoundManager::Play(int nID)
{
	const_iterator it = find(nID);
	if(it != end())
	{
		Play(it->second, it->second.m_nLoopCount);
	}
}

//----
// Đ܂
// ̃\bh͔Cӂ̓o^Ă鉹Ƃ͕ʂɃ[vݒs܂B
// param	nID			 ID
// param	nLoopCount	[v (-1Ŗ)
//----
void SoundManager::Play(int nID, int nLoopCount)
{
	const_iterator it = find(nID);
	if(it != end())
	{
		Play(it->second, nLoopCount);
	}
}

//----
// Đ܂
// param	rItem		ACe
// param	nLoopCount	[v (-1Ŗ)
//----
void SoundManager::Play(const SoundItem& rItem, int nLoopCount)
{
	// VXeƂĉĂȂꍇ͔܂
	if(m_bEnableSystem == false)
	{
		return;
	}

	// ʖɃTEhfoCXɃNGXg܂
	if(rItem.m_nType == SoundType::SE)
	{
		if(m_bEnableSE == true)
		{
			m_DeviceSE.Play(rItem, nLoopCount);
		}
	}
	else if(rItem.m_nType == SoundType::BGM)
	{
		if(m_bEnableBGM == true)
		{
			m_DeviceBGM.Play(rItem, nLoopCount);
		}
	}
}

//----
// ꎞ~܂
// param	nID		 ID
//----
void SoundManager::Pause(int nID)
{
	const_iterator it = find(nID);
	if(it != end())
	{
		Pause(it->second);
	}
}

//----
// ꎞ~܂
// param	rItem	~ACe
//----
void SoundManager::Pause(const SoundItem& rItem)
{
	// ʖɃTEhfoCXɃNGXg܂
	if(rItem.m_nType == SoundType::SE)
	{
		m_DeviceSE.Pause(rItem);
	}
	else if(rItem.m_nType == SoundType::BGM)
	{
		m_DeviceBGM.Pause(rItem);
	}
}

//----
// ~܂
// param	nID		 ID
//----
void SoundManager::Stop(int nID)
{
	const_iterator it = find(nID);
	if(it != end())
	{
		Stop(it->second);
	}
}

//----
// ~܂
// param	rItem	~ACe
//----
void SoundManager::Stop(const SoundItem& rItem)
{
	// ʖɃTEhfoCXɃNGXg܂
	if(rItem.m_nType == SoundType::SE)
	{
		m_DeviceSE.Stop(rItem);
	}
	else if(rItem.m_nType == SoundType::BGM)
	{
		m_DeviceBGM.Stop(rItem);
	}
}

//----
// o^Ă鉹̒擾܂
// param	nID		 ID
// return	0 ȊO	̒
//			0		ُI
//----
DWORD SoundManager::GetMediaLength(int nID)
{
	DWORD dwLength = 0;
	const_iterator it = find(nID);
	if(it != end())
	{
		// ʖɃTEhfoCXɃNGXg܂
		if(it->second.m_nType == SoundType::SE)
		{
			m_DeviceSE.GetMediaLength(it->second.m_FileName.c_str(), dwLength);
		}
		else if(it->second.m_nType == SoundType::BGM)
		{
			m_DeviceBGM.GetMediaLength(it->second.m_FileName.c_str(), dwLength);
		}
	}
	return dwLength;
}
